function GoBookParser () {
	
	/*
	 * Public
	 */

	this.parse = function(content) {
		/*
		 * chapter is a bit misleading here... as h1 also start a new chapter...
		  so chapter should be undertsood as a part of the book
		 */
		var cptChapter = 1;
		var chapters =[];
		var book = [];
		var tokens = content.trim().split(/\n\s*\n|\r\n\s*\r\n|\n(?=::)/); // split on empty lines
		//console.log(JSON.stringify(tokens));
		for(var i = 0;i < tokens.length;i++){
			var token = tokens[i];
			if (token.slice(0, "::".length) == "::" ) { // token starts with "::"
				var res = parseToken(token);

				res["__token"] = token;

				//if (res.cmd !== "c") {

					/*
					 * look ahead
					 */
					// try to find a the first heading following the chapter, something like h1 h2 h... 
					var chapterName = "";
					if (res.cmd.indexOf("h1") >-1) {
						var cid = (res.id) ? res.id : "Default-"+(cptChapter++);
						if (res.text && bookElem) {
							
							chapterName = res.text.replace(/#title#/g, bookElem.title)
								.replace(/#author#/g, bookElem.author)
								.replace(/#publisher#/g, bookElem.publisher)
								.replace(/#subtitle#/g, bookElem.subtitle)
								.replace(/#copyright#/g, bookElem.copyright);
						} else {
							chapterName = cid;
						}
						chapters.push({id:cid, name:chapterName, level:2});

					} else if ((res.cmd.indexOf("chapter") >-1) || (res.cmd.indexOf("book") >-1)) {

						for(var j = i+1;j < tokens.length;j++){
							var tmp = parseToken(tokens[j]);
							
							if ((tmp.cmd) && (tmp.cmd[0] == 'h' )) {
								var bookElem = (i===0) ? res : book[0] ;
								if ( tmp.text) {
									chapterName = tmp.text.replace(/#title#/g, bookElem.title)
											.replace(/#author#/g, bookElem.author)
											.replace(/#publisher#/g, bookElem.publisher)
											.replace(/#subtitle#/g, bookElem.subtitle)
											.replace(/#copyright#/g, bookElem.copyright);
								}
								break;

							} else if (tmp.cmd == "chapter") {
								break;
							}
						}
						var cid = (res.id) ? res.id : "Default-"+(cptChapter++);
						if (chapterName==="") {
							if (i===0) {
								chapterName = "Book - "+res.title;
							} else {
								chapterName = "["+cid+"]";
							}
						}
						chapters.push({id:cid, name:chapterName, level:1});
					}
					book.push(res);
				//} // cmd = ::c
			}
			else {
				book.push({cmd:"p", text:token}); // default token is p (paragraph)
			}
		}
		//console.log(JSON.stringify(book,null,2));
		return {book:book, partsTitles:chapters};
	};
	
	/*
	 * Internal use
	 */
	function parseToken (token) {
		//console.log ("Parsing token : "+token);
		var res = {};

		var myRegexp = /::([a-zA-Z0-9_]+)([(]#[^\s]+[)])?/g;
		var match = myRegexp.exec(token);
		var cmd = null;
		var id = null;
		
		var text = null;
		var index = 2; // ::
		// cmd
		if (match) {
			cmd =  match[1];
			index += match[1].length;
			// id
			if (match[2]) {
				id = match[2].substring(2,match[2].length-1);
				index += match[2].length;
			}
			res["cmd"] = cmd;
			res["id"] = id;
			
			var attsStr = token.substring(index);

			var key = "";
			var value="";
			var quotedValue = false;
			var readKey = true;
			var endValueChar ='"';
			var p = null;
			for (var i = 0;i< attsStr.length;i++ ) {

				var c = attsStr[i];
				
				if (readKey) {
					// read key
					if (c == '=') {
						res[$.trim(key)] = "";
						readKey = false; // read the value now...
					}  else {
						if (!(c===" " && key ==="")) {
							key = key + c;
							
						}
					}
				} else {
					if (!((value === "") && (c === " "))) { // skip space
						if ((value === "") && (c === '"') && (p!=="\\")) {
							quotedValue = true;
						} else {
							if ( (c != '"') || (p==="\\")) {
								value += c;
							}
						}

						// if ", close if value or if previous char is " (ie empty value liek in mv="")
						var endQuotedWords = (  (c === '"'  && p!=="\\")   && quotedValue &&  ((value !== "")  || ( p =='"'  )  )    );
						var endSingleWord = ((!quotedValue) && ( c === ' '));
						var newLine = (c==="\n");
						// is end value ?
						if (endQuotedWords ||  endSingleWord || newLine ) {
							readKey = true;
							key = $.trim(key);
							res[key] = buildValue(key,value);
							value = "";
							key = "";
							quotedValue = false;
						}
					}
				}

				// set preceding char
				p = c;
			} // end for loop
			
			if (value !== "") {
				key = $.trim(key);
				res[key] = buildValue(key,value);
			} else {
				if (key !== "") {
					text = key;
				}
			}
			
			
		} else {
			//console.log("Regexp not matching for line : ["+token+"]");
		}
		res["text"] = text;
		return res;
	}
	
	function buildValue (key,value) {
		
		if(key==="correct" || key==="wrong") {
			return buildSequencesMap(value);
		}

		var v = value;
		var is_az =  function(key) { return  ((key.length==1) && ((key.charCodeAt(0) - 96 ) >0  ) &&((key.charCodeAt(0) - 96 ) <27  )); };
		var is_AZ =  function(key) { return  ((key.length==1) && ((key.charCodeAt(0) - 64 ) >0  ) &&((key.charCodeAt(0) - 64 ) <27  )); };
		if ((key =="mv") || (key == "vw") || (key == "aw") || (key == "ab") || (key == "tr") || (key == "sq")  || (key == "ma")  || (key == "cr") || (key == "tb") || (key == "tw") || is_az(key) || is_AZ(key) ) {
			var res = v.replace(/\s/g,"")
				.toUpperCase()
				.match(/([A-Z][0-9]+|PASS|TENUKI)/g);
			return res;
		}
		return value.replace(/\\"/g,'"')
			.replace(/\\\\/g,'\\')
			.trim();
	}

	function buildSequencesMap(seqStr) {
		var seqs = seqStr.split(";");
		var obj = {};
		for (var i=0;i<seqs.length;i++) {
			var key ="";
			var comments={};
			var seq = seqs[i];
			var inComment = false;
			var currentMove = 0;
			var comment = "";
			var currentToken="";
			for (var j = 0;j< seq.length;j++) {
				var c = seq[j];
				if (c===" " && (!inComment)){
					continue;
				}
				if (c==="(") {
					inComment = true;
					comment="";
				} else if (c===")") {
					comments[currentToken] = comment;
					inComment = false;
					currentToken = "";
				} else if (inComment) {
					comment += c;
				} else {
					key+=c;
					if(c.match(/[A-Z]/)&&j>0) {
						currentToken ="";
					}
					currentToken +=c;
				}
			}
			obj[key.toUpperCase()] = comments;
		}
		return obj;
	}
	
}