var GBProblemHelper = {
	sgfToPrb : function(content, options) {
		//var content = content.replace(/^[\t| ]+/gm, '').trim(); // remove left spaces and tabs...
		
		//console.log(content);

		var kifu = WGo.Kifu.fromSgf(content);
		var setup = {ab:[], aw:[]};
		for (var n in kifu.root.setup) {
			setupStone = kifu.root.setup[n];
			if (setupStone.c == 1) {
				setup.ab.push(pointAsCoord(setupStone.x,setupStone.y));
			} else {
				setup.aw.push(pointAsCoord(setupStone.x,setupStone.y));
			}
		}
		//console.log(JSON.stringify(setup));
		var seqs=[];
		walkSgfTree(kifu.root,0,[]);
		//console.log(JSON.stringify(seqs,null,2));

		/*
		 *
		 */
		var pl="b";
		var prb="::prb";
		if (options) {
			if( options.vw) {
				prb +=" vw="+options.vw;
			}
			if (options.ca) {
				prb +=" ca=\""+options.ca+"\"";
			}
		}

		if (seqs.length > 0) {
			
			if (setup.ab.length>0) {
				prb +=" ab="+setup.ab.join("");
			}
			if (setup.aw.length>0) {
				prb +=" aw="+setup.aw.join("");
			
			}
			pl = "b";
			if (seqs[0][0].move.c  == -1 ) {
				pl = "w";
			}

			prb +=" pl="+pl;
			var correctSeqs = [];
			var wrongSeqs = [];
			
			for (var i=0;i<seqs.length;i++) {
				var seq = seqs[i];
				var seqLength = seq.length;
				
				var last_move_comment = (seq[seqLength-1].comment) ? seq[seqLength-1].comment :"";
				var moves = "";
				for (var j=0 ; j< seqLength; j++) {
					moves += seq[j].pos;
					if (seq[j].comment) {
						moves += "("+seq[j].comment+")";
					}
				}

				if ((i===0) || (last_move_comment.toUpperCase() =="RIGHT") || (last_move_comment.toUpperCase() =="CORRECT")) {
					correctSeqs.push(moves);
				} else {
					wrongSeqs.push(moves);
				}
			}
			if (correctSeqs.length > 0) {
				prb +=" correct=\""+ correctSeqs.join(";")+"\"";
			}
			if (wrongSeqs.length > 0) {
				prb +=" wrong=\"" +wrongSeqs.join(";")+"\"";
			}
		}
		
		return prb;

		/*
		 *
		 */

		function walkSgfTree(node,level,acc) {
			pos={}
			if (node.move) {
				var tab ="";
				for (var l = 0; l< level ; l++) {
					tab+="  ";
				}
				var mv = pointAsCoord(node.move.x, node.move.y);
				pos.pos = mv;
				pos.move = node.move;
				if (node.comment) {
					pos.comment = node.comment;
				}
				acc.push(pos);
			}
			//console.log(tab+""+mv+" ("+acc+")");
			if (node.children.length > 0) {
				//console.log(tab+""+mv+" ("+acc+")");
				level ++;
				for( var i = 0; i< node.children.length ;i ++ ) {
					var child = node.children [i];
					walkSgfTree(child, level, acc);
				}
			} else {
				//console.log(JSON.stringify(acc));
				seqs.push(JSON.parse(JSON.stringify(acc)));	
			}
			acc.pop();
		}
		function pointAsCoord(x,y) {
			if (x > 7){ x = x+1;} // skip the I letter
			var coord = String.fromCharCode(x+65)+(19-y);
			return coord;
		}
	},
	

	answerMove : function(elem,moveSeq,lastMove) {
		/*
		Default: If the problem is based on Go data that includes a move sequence, and this
		diagram doesn’t show that move sequence, then assume that move sequence is correct.
		*/
		if (elem.go_mv) {
			var mv_seq = elem.go_mv;
			if(!elem.correct) {
				elem.correct={};
			}
			if (! elem.correct[mv_seq]) {
				elem.correct[mv_seq] = {};
			}
		}

		var answer_comment=null;
		var move_comment=null;
		
		if(elem.correct) {
			var correct = elem.correct;
			for(var cor in correct) {
				if (cor.indexOf(moveSeq)===0) {
					var size=2; // A1
					if (cor[moveSeq.length+2] && cor[moveSeq.length+2].match(/[0-9]/)) {
						size=3 ; // A11
					}
					var nextMove = cor.substring(moveSeq.length,moveSeq.length+size);

					if (correct[cor][lastMove]) {
						move_comment = correct[cor][lastMove];
					}
					if (correct[cor][nextMove]) {
						answer_comment = correct[cor][nextMove];
					}
					return {pos:nextMove, move_comment:move_comment, answer_comment: answer_comment, path:"correct"};
				}
			}
		}
		if(elem.wrong) {
			var wrong = elem.wrong;
			for(var wr in wrong) {
				if (wr.indexOf(moveSeq)===0) {
					var size=2; // A1
					if (wr[moveSeq.length+2] && wr[moveSeq.length+2].match(/[0-9]/)) {
						size=3 ; // A11
					}
					var nextMove = wr.substring(moveSeq.length,moveSeq.length+size);

					if (wrong[wr][lastMove]) {
						move_comment = wrong[wr][lastMove];
					}
					if (wrong[wr][nextMove]) {
						answer_comment = wrong[wr][nextMove];
					}
					return {pos:nextMove, move_comment:move_comment, answer_comment: answer_comment, path:"wrong"};
				}
			}
		}
		
		return {pos:"",comment:"", path:"unexpected"};
	}
};