// dependency : gobook.util.js (GoBookUtil)
var SIZE = 20;
var CurrentPosMap = {};
var DRAW_BOARD = true;

/*
 * Kind of mock UI to help test/debug the engine (GoBookEngine)
 */

function GoBookBridge_UNIT_TEST (){
	var boardId = 0;
	
	/*
	 * API, WGO specific
	 */



	this.appendFigure = function(elem, twoPointsViewPort, base, moves, ab, aw, ca, startCountingAt) {


		
		var viewPort = wgo_ViewPort(twoPointsViewPort[0],twoPointsViewPort[1]);
		var dx = (19-viewPort.right) - viewPort.left;
		
		var data = {boardId:boardId,viewPort:viewPort,dx:dx,base:base,moves:moves,ab:ab,aw:aw, ca:ca,startCountingAt:startCountingAt};

		var text ="";
		if (ca) {
			text= ca;
		}
		boardId++;
		return toStr(data);
	};
		
	/*
	 * API, Non WGO specific
	 */
	this.startToken = function (elem, id) {return "";};

	this.endToken = function (elem) {return "";};

	this.appendEditToolBar = function (elem,pos) {return "";};

	this.init = function() {};

	this.appendHeader = function (elem) {
		var res = "<"+elem.cmd+">"+elem.text+"</"+elem.cmd+">";
		return res;
	};
	this.appendSection = function (elem) {
		var res = "<h"+elem.cmd[1]+">"+elem.text+"</h"+elem.cmd[1]+">";
		return res;
	};
	this.appendParagraph = function (elem) {
		var res = "<p class='text'>"+elem.text+"</p>";
		return res;
	};
	
	function wgo_ViewPort (leftBottom, rightTop) {
		var p1 = coordAsPoint(leftBottom); // p1 = {x, y}
		var p2 = coordAsPoint(rightTop); // p1 = {x, y}
		return {
			left : p1.x-1,
			bottom : p1.y -1,
			right : 19- p2.x,
			top : 19 - p2.y
		};
	}}

/*
 * NON API (not used by the engine)
 */
function toStr(data){
		/*
         * pseudo "SGF like" representation, but with letter (withoutI ) and number... so that it's more
         * easy to compare with gobook structure...
         */

		var boardId = data.boardId;
		var dx = data.dx;
		var base = data.base;
		var moves = data.moves;
		var ab = data.ab;
		var aw = data.aw;
		var viewPort = data.viewPort;
		var startCountingAt = data.startCountingAt;
		
		var res="";
		res+=";AB[";
		for (var i in ab) {
			
			if (i>0) {
					res+=",";
				}
			res+=placeStone(  ab[i],  WGo.B, null);
		}
		res+="]";

		res+=";AW[";
		for (var i in aw) {
			if (i>0) {
					res+=",";
				}
			res+=placeStone(  aw[i],  WGo.W, null);
		}
		res+="]";
		res+=" - ";
		
		// this "pre" stones behaves a bit like AB and AW stones...
		// closes enouth for testing purpose...
		
		if (base && base.length>0) {
			
			for (var i=0; i< base.length; i++) {
				var label ="";
				label = ""+(i+startCountingAt);
				var _mv = (base[i].c === 1) ? ";b[" : ";w[";
				
				_mv += placeStone(  base[i], label) + "]";
				res+= _mv;
				
			}
		} else {
			res+="none";
		}
		//res+="\n";
		res+=" - ";
		if (moves) {
			
			

			
			for (var i=0; i< moves.length; i++) {
				var label ="";
				//label = ""+(i+startCountingAt);
				var _mv = (moves[i].c === 1) ? ";B[" : ";W[";
				
				_mv += placeStone(  moves[i], label) + "]";
				res+= _mv;
			
			}
		}

		if(!moves || moves.length === 0) {
			res+="NONE";
		}
		//res+="\n";
		return res;
		
	}

	function placeStone(  m, label) {

		return  pointAsCoord(m);

		// This would be more sgf...
		//return  String.fromCharCode(96+m.x)+String.fromCharCode(96+m.y);
	}


function wgo_Move(coord, color) {
	var m = coordAsPoint(coord);
	var wgoMove = {
		x:m.x-1,
		y:19-m.y,
		c:color
	};
	return wgoMove;
}

function coordAsPoint (coord) {
	// coord : 'A1' (left/Bottom) to 'T19' (right/Top)
	// return a point {x,y} from 1,1 to 19,19

	var x = coord.charCodeAt(0) - 65 + 1;
	var y = parseInt(coord.substring(1),10);

	if (x>=9) {
		x = x-1; // skip letter I
	}
	return {x:x,y:y};
}

function pointAsCoord (p) {
	// coord : 'A1' (left/Bottom) to 'T19' (right/Top)
	// return a point {x,y} from 1,1 to 19,19
	var x = p.x;
	if (x >=8) {
		x++;
	}
	return String.fromCharCode(65+x)+(19 - p.y);
}


